; -------------------------------------------
; 		 Variabeln fr den Text
; -------------------------------------------
Global HTML_HTMLPosX
Global HTML_HTMLPosY
Global HTML_HTMLSizeX = 400
Global HTML_HTMLSizeY = 400
Global HTML_NextWordPointer = 1

; Darstellungsvariabeln fr Objekte
Global HTML_CurX
Global HTML_CurY
Global HTML_CurMaxHeight
Global HTML_CurOffset
Global HTML_CurStart
Global HTML_OffsetX
Global HTML_OffsetY


; Variabeln fr das Design

Global HTML_FontColor
Global HTML_BgColor
Global HTML_FontName$
Global HTML_FontStandardSize = 19
Global HTML_FontSize
Global HTML_FontCenter
Global HTML_FontisBold
Global HTML_FontisItalic
Global HTML_FontisUnderlined
Global HTML_HTMLImage
Global HTML_HTMLRendered = False
Global HTML_FontOffset# = (80./100)
Global HTML_Font
Global HTML_HTMLTitle$


Global HTML_BefehlDefinitionen = 0
Global HTML_ParameterDefinitionen = 0

Dim HTML_FontColorCodeDef$(150)
Dim HTML_FontColorCode$(150)

Dim HTML_SonderTag$(100,1)

Dim HTML_BefehlDefParameter(100)
				; Array zum Abspeichern der Parametercodes der Befehle

Dim HTML_BefehlDefParameterDef(100,1)
				; HTML_BefehlDefParameterDef(i,0) = Parameteranzahl
				; HTML_BefehlDefParameterDef(i,1) = Position des 1. Parameters

Dim HTML_BefehlDef$(100)
				; Speichert smtliche Befehle
				
Dim HTML_ParameterDef$(100)
				; Speichert smtliche Parameter ab

; -------------------------------------------
; 		     Variabeln fr Fehler
; -------------------------------------------
Const ERROR_NoParameter = 1
Const ERROR_HTMLFileNotFound = 2

Global HTML_HTMLPath$
Global HTML_FileLoaded = False
Global HTML_HTMLFile
					

; -------------------------------------------
; 		     Variabeln zum auslesen
; ------------------------------------------- 
Const TYPE_Unknown = -1
Const TYPE_Befehl = 1
Const TYPE_EndTag = 2
Const TYPE_Text = 3

Const HTML_ObjectImage = 1
Const HTML_ObjectText  = 2

Global HTML_BefehlAnzahl
Global HTML_BefehlPointer

Global HTML_ParameterPointer
Global HTML_TextPointer

Dim HTML_Befehl(5000,3)		;Speichert alle Befehle der HTML ab, wie "font", "center", etc...
						 	;HTML_Befehl(x,0) = Befehlscode
							;HTML_Befehl(x,1) = Parameteranzahl
							;HTML_Befehl(x,2) = Position des 1. Parameters
							;HTML_Befehl(x,3) = 1: EndTag wurde gefunden, 0:Kein EndTag vorhanden


Dim HTML_Parameter(5000)	;Parameter zu Befehlen
Dim HTML_Wert$(5000) 		;Werte der Parameter
Dim HTML_Text$(5000)		;Normaler Anzeigbarer Text

; -------------------------------------------
; 		     Zwischenspeichervariabeln
; -------------------------------------------
Dim HTML_FontBuffer(100,4)	;HTML_FontBuffer(i, 0) = Font
							;HTML_FontBuffer(i, 1) = Size
							;HTML_FontBuffer(i, 2) = bold
							;HTML_FontBuffer(i, 3) = italic
							;HTML_FontBuffer(i, 4) = underlined

Dim HTML_FontBufferName$(100) ;Font Name

Global HTML_FontPointer

Global HTML_BufferPointer

Dim HTML_Buffer(3000,1)
							;HTML_Buffer(i, 0) = Parameter Code
							;HTML_Buffer(i, 1) = Befehl Code

Dim HTML_BufferWert$(3000) ;Wert des Parameters

HTML_ReadHTMLBefehle()

; Zeichnet die HTMLDatei
Function DrawHtmlDocument( HTML_File$ = "NODOCUMENT")

	; Prfen, ob ein Parameter bergeben wurde
	If HTML_File$ = "NODOCUMENT"

		HTML_Error(ERROR_NoParameter)
		
	Else

		If HTML_HTMLPath$="" ; Falls noch keine HTML-Datei gesetzt wurde
			
			HTML_HTMLPath$ = HTML_File$
			; Prfen, ob die HTML-Datei existiert	
			If FileType(HTML_File$) <> 1 HTML_Error(ERROR_HTMLFileNotFound) Else HTML_LoadHTMLFile()
				
		Else  ;Falls gesetzt wurde..
		
			If HTML_HTMLPath$ <> HTML_File$ ; prfen ob eine neue Datei angegeben wurde

				 HTML_HTMLPath$ = HTML_File$ : HTML_FileLoaded = False : HTML_HTMLRendered = False
				; Prfen, ob die HTML-Datei existiert	
				If FileType(HTML_File$) <> 1 HTML_Error(ERROR_HTMLFileNotFound) Else HTML_LoadHTMLFile()
	
			End If
				
		End If 

	End If
		
	
	HTML_RenderHTML()
	
	Viewport HTML_HTMLPosX, HTML_HTMLPosY, HTML_HTMLSizeX, HTML_HTMLSizeY ;ViewPort setzen

	; Stelle die HTML-Seite Da
	DrawBlock HTML_HTMLImage, HTML_HTMLPosX - HTML_OffsetX, HTML_HTMLPosY - HTML_OffsetY
	
	Viewport 0,0,GraphicsWidth(),GraphicsHeight()
	
End Function

Function HTML_AddFont()

	HTML_FontPointer = HTML_FontPointer + 1
	i = HTML_FontPointer
	
	HTML_FontBuffer(i,0) = HTML_Font
	HTML_FontBuffer(i,1) = HTML_FontSize
	HTML_FontBuffer(i,2) = HTML_FontisBold
	HTML_FontBuffer(i,3) = HTML_FontisItalic
	HTML_FontBuffer(i,4) = HTML_FontisUnderlined
	
	HTML_FontBufferName$(i) = HTML_FontName$

End Function

Function HTML_ClearImage()

 	If HTML_HTMLImage = 0
		HTML_HTMLImage = CreateImage(2000, 2000)
	End If
	
	curBuffer = GraphicsBuffer()
	
	SetBuffer ImageBuffer(HTML_HTMLImage)
		ClsColor 0, 0, HTML_BgColor : Cls
	SetBuffer curBuffer
	
End Function

Function HTML_ClearMemory()

	HTML_FileLoaded = False
	HTML_HTMLRendered = False

	For i = 1 To HTML_FontPointer ;Lsche alle bisher geladenen Fonts
		FreeFont HTML_FontBuffer(i,0)
	Next
	
	HTML_FontPointer = 0
	Dim HTML_FontBuffer(100,4)
	Dim HTML_FontBufferName$(100)

	FreeImage HTML_HTMLImage ;Lsche das HTML_Bild
	HTML_HTMLImage = 0
	
	HTML_HTMLPath$ = ""
	
End Function

Function HTML_DoParameter()

	i = HTML_BefehlPointer

	If HTML_Befehl(i, 1)>0 ;Checke auf Parameter
		
		BefCode 	= HTML_Befehl(i, 0) ;BefehlCode auslesen
		befehl$ 	= HTML_BefehlDef$(BefCode) ;Befehlbeschreibung
		HTML_ParameterPointer = HTML_Befehl(i, 2) ;Hohle den Bezug zum Parameter
			
		For durchlauf = 1 To HTML_Befehl(i,1)

			ParCode     = HTML_Parameter(HTML_ParameterPointer)  ;Hohle den Parameter Code

			parameter$ 	= HTML_ParameterDef$(ParCode) ;Parametcode in Worte umwandeln
						
			wert$ 		= HTML_Wert$(HTML_ParameterPointer)      ;Den Inhalt des Parameters ermitteln
			
			; /////////////////////////////////////////////////
			; /             Parameter auslesen                /
			; /////////////////////////////////////////////////
			Select parameter$
			
				Case "color"
				
					Select befehl$					
					
						Case "font"

							;Alten Farbwert sichern
							HTML_SaveBuffer(BefCode, ParCode, HTML_FontColor)

							If Left$(wert$, 1) = "#" ;Wenn es sich um ein Hexwert handelt
							    ;Hexwert holen
								HTML_FontColor = HTML_HexToDez(Right$(wert$, Len(wert$) - 1))
							Else ; Wenn es kein Hexwert ist

								HTML_FontColor = HTML_HexToDez(wert$) ;Probieren ob "#" vergessen
																	  ;wurde


								For a=1 To 150 ;Suche sonst nach eventuellen Begriff
									If HTML_FontColorCodeDef$(a) = wert$ ;Suche passenden Code
										HTML_FontColor = HTML_FontColorCode(a) : Exit ; Setze diesen
									End If
								Next
								
							End If

							Color 0,0,HTML_FontColor
							
					End Select
				
				Case "size"
				
					Select befehl$
					
						Case "font"

							HTML_setFontSizeByString(wert$, BefCode) ;Setze die neue Schriftgre und 
													   		   				  ;speichere durch den Flag '1' den
			     															  ;alten Schriftwert							
					End Select
					
				Case "src"
					
					If FileType(wert$) ;Pfrft, ob der DateiPfad gefunden wurde
					
						img = LoadImage(wert$) ;Ldt das Bild
						
						If img>0 HTML_RenderObject(img, HTML_ObjectImage) : FreeImage img ; Rendere das Bild und lsche
																		; es wieder
						
					End If
					
			End Select

						
			HTML_ParameterPointer = HTML_ParameterPointer + 1; Parameter Pointer verschieben
						
		Next
							
	End If
End Function

Function HTML_DoZeilenUmbruch()

	If HTML_CurMaxHeight = 0 Then HTML_CurMaxHeight = FontHeight();Wenn CurMaxHeight noch nicht
																	;gesetzt wurde																	

	If HTML_FontCenter = 1 And HTML_CurX>0 And HTML_CurX<HTML_HTMLSizeX
		HTML_CurX = HTML_CurX - StringWidth(" ")
						;Falls Center aktiv ist, dann wird bei einem Zeilenumbruch die aktuelle
						;Zeile in die mitte des Bildes gebracht
											
						
		mx = ((HTML_HTMLSizeX-HTML_CurStart)/2) - (HTML_CurX/2) ;Ermittle X, damit die Zeile
																	 ;auf die Mitte des Bildes	
																	 ;gezeichnet werde kann
		
		CopyRect HTML_CurStart, HTML_CurY, HTML_CurX, HTML_CurMaxHeight + HTML_CurOffset, mx, HTML_CurY ;Zeile mittig
		
		Color 0,0,HTML_BgColor ;Setze die Farbe des berschreibenden Rechtecks auf die
							   ;Hintergrundfarbe

		Rect HTML_CurStart, HTML_CurY, mx, HTML_CurMaxHeight + HTML_CurOffset
											 ;Lscht den Teil vor der Zeile, der ber
											 ;bleibt

		Color 0,0,HTML_FontColor ;Setze die Farbe wieder auf die aktuelle Schriftfarbe
		
	End If
																
	HTML_CurX = 0 								;Setze den X-Cursor auf 0 zurck
	HTML_CurY = HTML_CurY + HTML_CurMaxHeight + HTML_CurOffset
											   ;Setze den Y-Cursor eine Zeile weiter
		
	HTML_CurMaxHeight = 0 ;MaxHhe der Zeile auf die Hhe des momentanen Objekt setzen
	HTML_CurOffset 	  = 0 ;Der Offset(wenn z.B. ein Text gerendert wurde, wird zurckgesetzt

End Function

Function HTML_EndBefehl()

    i = HTML_BefehlPointer

    BefCode 	= HTML_Befehl(i, 0)-1000   ;Befehlcode auslesen (-1000 weil >1000 den Endtag angibt)
    befehl$	 	= HTML_BefehlDef$(BefCode) ;Befehlbeschreibung	

;	Print
;	Print
;	Print befehl$
;	Delay 500
	
	If HTML_Befehl(i, 1) = 0 ;Checke auf Parameter

		Select befehl$
			Case "br"	  : HTML_DoZeilenUmbruch()
			
			Case "center" : HTML_DoZeilenUmbruch() : HTML_FontCenter = 0
			
			Case "h1" : HTML_DoZeilenUmbruch() : HTML_setFontSize(Int(HTML_getBuffer(BefCode, HTML_FindParameter("size"))))
												 HTML_setFontBold(Int(HTML_getBuffer(BefCode, HTML_FindParameter("bold"))))
						HTML_DoZeilenUmbruch()

			Case "i" : HTML_setFontItalic(Int(HTML_getBuffer(BefCode, HTML_FindParameter("italic"))))

			Case "u" : HTML_setFontUnderlined(Int(HTML_getBuffer(BefCode, HTML_FindParameter("underlined"))))

		End Select
	
	Else
	
	HTML_ParameterPointer = HTML_Befehl(i, 2) ;Hohle den Bezug zum Parameter
			
		For durchlauf = 1 To HTML_Befehl(i, 1) ;Durchlaufe alle Parameter

			ParCode     = HTML_Parameter(HTML_ParameterPointer)  ;Hohle den Parameter Code

			parameter$ 	= HTML_ParameterDef$(ParCode) ;Parametcode in Worte umwandeln
			
;			Print
;			Print "ENDBEFEHL"
;			Print "Parameteranzahl: " + HTML_Befehl(i, 1)
;			Print parameter$
;			Delay 1000
			; /////////////////////////////////////////////////
			; /             Parameter auslesen                /
			; /////////////////////////////////////////////////
			Select parameter$
			
				Case "color"
				
					Select befehl$					
					
						Case "font"

							HTML_FontColor = Int(HTML_getBuffer$(BefCode, ParCode)) ;Hole Farbwert
				    		Color 0,0,HTML_FontColor ;Setze Farbwert								
											
					End Select
				
				Case "size"
				
					Select befehl$
					
						Case "font"							
							
							HTML_setFontSize(Int(HTML_getBuffer$(BefCode, ParCode)))
		
					End Select
					
			End Select

						
			HTML_ParameterPointer = HTML_ParameterPointer + 1; Parameter Pointer verschieben
						
		Next
	End If
End Function

; Bricht das Validieren des HTML-Documents mit einer Fehlermeldung ab
Function HTML_Error(HTML_Error)

	; Sucht nach dem Fehler und behandelt diesen entsprechend
	Select HTML_Error
		Case ERROR_NoParameter 		: message$ = "Es wurde fr DrawHTMLDocument() keine HTML-Datei angegeben"
		Case ERROR_HTMLFileNotFound : message$ = "Die HTML-Datei '" + HTML_HTMLPath$ + "' wurde nicht gefunden"
	End Select

 	; Zeigt den Fehler visuell an
	ClsColor 0,0,0 : Cls
	Color 255,0,0

	Print "Fehler in der Funktion DrawHTMLDocument():"

	If message$<>""	Print message$ Else	Print "Es existiert keine Beschreibung fr den Fehlercode " + HTML_Error
	
	Print "Drcken Sie eine beliebige Taste zum Beenden..."
	WaitKey()
	End
	
End Function

Function HTML_FindBefehl(befehl$)

	befehl$ = Lower$(befehl$)
	
	; Falls es sich um ein EndTag handelt, dann das "/"-Zeichen rausschneiden
	If Left$(befehl$, 1) = "/" EndTag = 1 : befehl$ = Right$(befehl$, Len(befehl$) - 1)
	
	For a=1 To HTML_BefehlDefinitionen
		If HTML_BefehlDef$(a) = befehl$ Then Return a + (1000 * endtag) Else 
	Next
	
End Function

Function HTML_FindEndTag(Pointer)

	BefehlCode = HTML_Befehl(Pointer, 0) ;Hohle den Befehlscode

	For Pointer2 = Pointer To HTML_BefehlAnzahl ;End-Tag fr Title suchen

		EndTag = HTML_Befehl(Pointer2, 0)-1000  ;Befehlscode holen
							
		If EndTag = BefehlCode ;EndTag entspricht dem Befehl?

			Return Pointer2 ;Gebe den Pointer des EndTags zurck
			
		End If
					
	Next

End Function
	
Function HTML_FindFont()

	For i=1 To HTML_FontPointer ;Sucht nach Fonts

		; Prft ob es bereits einen Font mit diesen Angaben existiert
		If HTML_FontName$ = HTML_FontBufferName$(i)	And HTML_FontSize = HTML_FontBuffer(i,1) And HTML_FontisBold = HTML_FontBuffer(i,2) And HTML_FontisItalic = HTML_FontBuffer(i,3) And HTML_FontisUnderlined = HTML_FontBuffer(i,4)
			Return i
		End If
		
	Next

End Function

Function HTML_FindParameter(parameter$)

	parameter$ = Lower$(parameter$)
	
	For a=1 To HTML_ParameterDefinitionen
		If HTML_ParameterDef$(a) = parameter$ Then Return a
	Next
	
End Function

Function HTML_getBefehlType()
	
	i = HTML_BefehlPointer
	
	If HTML_Befehl(i, 0) > 0 And HTML_Befehl(i, 0) < 1000 Return TYPE_Befehl
	If HTML_Befehl(i, 0) > 1000 Return TYPE_EndTag
	If HTML_Befehl(i, 0) = -1 Return TYPE_Text
	
	Return TYPE_Unknown
	
End Function

Function HTML_getBuffer$(BefCode, ParCode)

	For i = HTML_BufferPointer To 1 Step -1 ;Durchlaufe von hinten alle Bufferwerte
	
		;Falls der Parametercode und der BefehlCode bereinstimmt
		If BefCode = HTML_Buffer(i,0) And ParCode = HTML_Buffer(i,1)

			returnvalue$ = HTML_BufferWert$(i)
		
			For move = i To HTML_BufferPointer - 1 ;Lsche den Eintrag
			
				HTML_Buffer(move,0) = HTML_Buffer(move+1,0) ;Verschiebe BefehlCode
				HTML_Buffer(move,1) = HTML_Buffer(move+1,1) ;Verschiebe ParameterCode

				HTML_BufferWert$(move) = HTML_BufferWert$(move+1) ;Verschiebe den Wert
				
			Next
			
			HTML_Buffer(HTML_BufferPointer,0) = 0 ;Letzten Wert lschen
			HTML_Buffer(HTML_BufferPointer,1) = 0 ;Letzten Wert lschen
			
			HTML_BufferPointer = HTML_BufferPointer - 1 ;Den Pointer um eins runtersetzen
			
			Return returnValue$
			
		End If
		
	Next
	
End Function

Function HTML_getText$()

	Return HTML_Text$(HTML_Befehl(HTML_BefehlPointer, 2)) ;Liefert den Text des derzeitigen Befehls
														  ;zurck. HTML_Befehl(i, 2) reprsentiert
														  ;hierbei den TextPointer zu HTML_Text$(i)
End Function

Function HTML_HexToDez(hexa$)
  For i=1 To Len(hexa$)
   If Asc(Mid$(hexa$,i))<=57 hexwert=Mid$(hexa$,i, 1) Else hexwert=Asc(Mid$(hexa$,i, 1))-55
   zeichen = Len(hexa$)-i
   byte = byte + Int(hexwert*(16^zeichen))   
 Next

 Return byte
End Function

Function HTML_NextBefehl()

	HTML_BefehlPointer = HTML_BefehlPointer + 1	;Verschiebe den Pointer
	code = HTML_Befehl(HTML_BefehlPointer,0)
		
	Return code

End Function

Function HTML_NextBefehlExists()
	
	If HTML_Befehl(HTML_BefehlPointer+1, 0)<>0
	
		Return True ;Gibt True zurckt wenn ein nchster Befehl lesbar ist
	
	Else
	
		HTML_BefehlPointer = 0
		Return False ;Gibt False zurck, wenn kein nchster Befehl gefunden wurde

	End If
	
	
End Function

Function HTML_NextWord$( st$ )
	st$ = HTML_Trim$(st$) ; Schneide Leere Zeichen aus dem Wort
	
	i = Instr(st$, " ", HTML_NextWordPointer) ;Suche nach einen nachfolgenden Wort
	
	If i>0 ;Wenn ein Nachfolgendes Wort gefunden wurde

		word$ = Mid$(st$, HTML_NextWordPointer, i - HTML_NextWordPointer) ;Hole das Wort
		HTML_NextWordPointer = i + 1 ;Verschiebe den Pointer
		
	Else
		If HTML_NextWordPointer = 1 ;Wenn der Pointer sich nicht bewegt hat, den String komplett
									;bernehmen
			word$ = st$
		Else
			word$ = Right$(st$, Len(st$) - HTML_NextWordPointer + 1) ;Hole das letzte Wort
		End If
		
		HTML_NextWordPointer = -1 ;Pointer auf "beendet" setzen
	End If
	
	word$ = HTML_TranslateCommands$(word$) ;Finde Sonderbefehle wie &nbsp; und bersetze
		
	Return word$
End Function

Function HTML_NextWordExists( st$ )

	If HTML_NextWordPointer>0 Then Return True

	If HTML_NextWordPointer=-1
		HTML_NextWordPointer = 1
		Return False
	End If
	
End Function

Function HTML_getHTMLText$(BefehlA, BefehlB)

	SeekFile(HTML_HTMLFile, 0) ;Setze den Pointer auf 0
	
	While Not Eof(HTML_HTMLFile) ;Liest bis an das Ende der HTML-Datei
	
		zeile$ = HTML_ReadHTMLLine$(HTML_HTMLFile) ;Liest Zeile fr Zeile

		For pos = 1 To Len(zeile$)

			st$ = Mid$(zeile$, pos, 1) ;Einzelner Buchstabe
			
		 	If st$ <> "<"

				HTMLText$ = HTMLText$ + st$
				
			Else

				If HTMLText$<>""
					If FindLastBefehl = 1 Then LongText$ = LongText$ + HTMLText$
					HMLText$ = "" : BefehlNr = BefehlNr + 1
				End If

				If BefehlNr = BefehlB Then Return LongText$
				
				; Checke ob die Befehlszeile mit > geschlossen wurde
				endpos = Instr(zeile$, ">", pos)

				If endpos>0 ;Wenn es eine Befehlszeile ist

					BefehlNr = BefehlNr + 1
					
					befehl$ = Mid$(zeile$ , pos, 1 + endpos - pos) ;Befehlszeile herausschneiden
					pos = endpos
				Else

					; Wenn kein > gefunden wurde, wird das Zeichen "<" als normaler Text bernommen				
					HTMLText$ = "<"
										
				End If

				If FindLastBefehl = 1 Then LongText$ = LongText$ + befehl$ : befehl$ = ""

				If BefehlNr = BefehlA Then FindLastBefehl = 1
			End If

		Next
	Wend
	
End Function

; Liest die HTML-Datei ein
Function HTML_LoadHTMLFile()

	If HTML_HTMLFileLoaded = True Return ;Falls die HTML-Datei bereits geladen wurde	

	If HTML_HTMLFile>0 	CloseFile HTML_HTMLFile ;Falls bereits eine HTML-Datei geffnet wurde
	Dim HTML_Befehl(5000,3)
	
	HTML_HTMLTitle$			= "" ;HTML-Titel zurck setzen. An dieser Stelle, weil, wenn die HTML
								 ;neu gerendert wird, ndert sich ja nicht der Titel
								
	HTML_ResetPointer()

	; Lese die Datei ein
	HTML_HTMLFile = ReadFile(HTML_HTMLPath$)
	
	; ===================================================
	; So lange lesen, bis das Ende der Datei erreicht ist
	
	While Not Eof(HTML_HTMLFile)

		; Liest Zeile fr Zeile (Tab (ASCII:9) wird herausgenommen)
		zeile$ = HTML_ReadHTMLLine$(HTML_HTMLFile)
		
		; Lese alle Befehle aus
		For pos = 1 To Len(zeile$)
		
			st$ = Mid$(zeile$, pos, 1) ;Einzelner Buchstabe

			; //////////////////////////////////////////////
			; /			Normalen Text auslesen             /
			; //////////////////////////////////////////////
		 	If st$ <> "<"
	
				HTMLText$ = HTMLText$ + st$
			Else

				; //////////////////////////////////////////////
				; /			Normalen Text speichern            /
				; //////////////////////////////////////////////
				; Speichere den Text ab
				If HTMLText$<>""
					HTML_putText(HTMLText$)
					HTMLText$ = ""
				End If
				
				; Checke ob die Befehlszeile mit > geschlossen wurde
				endpos = Instr(zeile$, ">", pos)

				; //////////////////////////////////////////////
				; /			Befehszeile auslesen               /
				; //////////////////////////////////////////////
				If endpos>0 ;Wenn es eine Befehlszeile ist
					
					befehl$ = Mid$(zeile$ , pos + 1, endpos - pos - 1) ;Befehlszeile herausschneiden
					nebenpos = Instr(befehl$, " ") ;Nach Nebenbefehle suchen
					pos = endpos ; Pointer verschieben
					
					; //////////////////////////////////////////////
					; /			Parameter auslesen                 /
					; //////////////////////////////////////////////
					If nebenpos <> 0 ;Wenn es NebenBefehle gibt

						hauptbefehl$ = Mid$(befehl$, 1, nebenpos - 1) ;Hauptbefehl herausschneiden

						HTML_putBefehl(hauptbefehl$) ;Hauptbefehl speichern
		
						;----------
						For i = nebenpos+1 To Len(befehl$) ;Alle Nebenbefehle durchlaufen
							st2$ = Mid$(befehl$, i, 1)

							If st2$<>" " nebenbefehl$ = nebenbefehl$ + st2$ ;Liest den Parameter aus
							
							; Verarbeitung eines Parameters mit Wert
							If st2$=" " Or i = Len(befehl$) ; Verarbeitet den Parameter

								parameter$ = HTML_ReadParameter$(nebenbefehl$)  ;Parameter auslesen

								;Wert auslesen
								wert$ = Replace$(HTML_ReadWert$(nebenbefehl$), Chr$(34), "")
																												
;								Print "Parameter: " + parameter$
;								Print "Wert: " + wert$

								HTML_putParameter(parameter$) ;Parameter abspeichern
								HTML_putWert(wert$)			  ;Wert abspeichern
								nebenbefehl$ = ""			  ;Nebenbefehl lschen
								
							End If
							
						Next
						;----------
					Else
					
						; Wenn es keine Nebenbefehle gibt
						HTML_putBefehl(befehl$)
;						 "Hauptbefehl: " + befehl$

					End If

;					Print "---"
					;Delay 250
				Else

					; Wenn kein > gefunden wurde, wird das Zeichen "<" als normaler Text bernommen				
					HTMLText$ = "<"
					
				End If
				
			End If
			

		Next

	Wend
	
	If HTMLText$<>"" ;Da diese Zeile nur ausgefhrt wird, wenn ein Befehl gefunden wurde, so muss sie
					 ;auch validiert werden, wenn es garkeine Befehle gibt
		HTML_putText(HTMLText$)
		HTMLText$ = ""
	End If

	;
	; ====================================================	
	
	HTML_BefehlAnzahl = HTML_BefehlPointer ;Anzahl der Befehle setzen
	
	HTML_HTMLFileLoaded = True ;HTML-Datei wurde erfolgreich geladen
	
End Function

Function HTML_LoadDefaultValues()
	
	HTML_BgColor 			= $FFFFFF
	HTML_CurX 				= 0
	HTML_CurY 				= 0
	HTML_CurMaxHeight		= 0
	HTML_CurOffset			= 0
	HTML_CurStart			= 0
	HTML_FontColor 			= $000000 : Color 0,0, HTML_FontColor
	HTML_FontisBold   	 	= False
	HTML_FontisItalic 	 	= False
	HTML_FontisUnderlined	= False
	HTML_FontName$ 			= "Times New Roman"
	HTML_FontSize 			= HTML_FontStandardSize

	HTML_setFont()

End Function

Function HTML_putBefehl(befehl$)

	code = HTML_FindBefehl(befehl$) ;Finde den Code zum Befehl

	HTML_putBefehlCode(code)		;Speichere den Code	
	
End Function

Function HTML_putBefehlCode(code)

	HTML_BefehlPointer = HTML_BefehlPointer + 1	;Verschiebe den Pointer
	HTML_Befehl(HTML_BefehlPointer, 0) = code   ;Speichere den Code	
	
	If code>1000 ;Wenn dieser Code ein EndTag ist

		For i = HTML_BefehlPointer To 1 Step -1

			If HTML_Befehl(i, 0) = code - 1000 And HTML_Befehl(i,3) = 0;Wenn der Code dem EndTag
																	 ;entspricht und noch kein EndTag
																	 ;erhalten hat
;				Print HTML_BefehlDef$(code - 1000)
				HTML_Befehl(HTML_BefehlPointer, 1) = HTML_Befehl(i, 1) ;bertrage die Parameteranzahl
				HTML_Befehl(HTML_BefehlPointer, 2) = HTML_Befehl(i, 2) ;bertrage 1. Position des
				
				HTML_Befehl(i, 3) = 1 ;Setze fr den Befehl, dass der EndTag gefunden wurde
;				Print "Parameteranzahl: " + HTML_Befehl(HTML_BefehlPointer, 1)
;				Delay 500						   ;Parameters
				Exit
			End If
			
		Next
		
	End If
End Function

Function HTML_putParameter(parameter$)
	
	code = HTML_FindParameter(parameter$) ;Hole den passenden Code zum Parameter
	
	HTML_ParameterPointer = HTML_ParameterPointer + 1 ;Pointer verschieben
	HTML_Parameter(HTML_ParameterPointer) = code      ;Code abspeichern

	BPoint = HTML_BefehlPointer ;Befehel Pointer zwischenspeichern
	
	If HTML_Befehl(BPoint, 2) = 0 ;Wenn der Pointer zum ersten Parameter noch nicht abgespeichert
								  ;wurde, dann dies tun

		HTML_Befehl(BPoint, 2) = HTML_ParameterPointer ;Der Bezug zum ersten Parameter wird
													   ;abgespeichert

	End If

	
	HTML_Befehl(BPoint, 1) = HTML_Befehl(BPoint, 1) + 1 ;Anzahl der Parameter erhhen

	
End Function

Function HTML_putText(TextString$)
	HTML_putBefehlCode(-1) ;Speichere den Code -1 fr Text
	
	HTML_TextPointer = HTML_TextPointer + 1    ;Text-Pointer erhhen
	HTML_Text$(HTML_TextPointer) = TextString$ ;Text speichern
	
	HTML_Befehl(HTML_BefehlPointer, 2) = HTML_TextPointer ;Speichern der Position zum Text
	
End Function

Function HTML_putWert(wert$)

	HTML_Wert$(HTML_ParameterPointer) = Lower$(wert$)

End Function


; ===================================================================================================
; ===================================================================================================


; Entfernt berflige Leerzeichen und schmeit die Remarks aus den Dateien
Function HTML_ReadFormatedLine$(datei)
 st$ = HTML_Trim$(ReadLine$(datei))

 While Left$(st$,1)="*" Or st$="" Or remstart=1 Or Left$(st$,2)="/*" Or Left$(st$,1)=";"
  If Mid$(st$,1,2)="/*" Then remstart=1
  If remstart=1 And (Left$(st$,2)="*/" Or Right$(st$,2)="*/") Then remstart=0
  If Eof(datei) Then Exit Else st$ = HTML_Trim$(ReadLine$(datei))
 Wend

 If Mid$(st$,1,1)="*" Then st$=""
 Return st$
End Function

Function HTML_ReadParameter$(st$,find$ = "=")
 For a=1 To Len(st$)
  If Mid$(st$,a,1)=find$ Then st$=HTML_Trim$(Left$(st$,a-1)) : Exit
 Next
 Return st$
End Function

Function HTML_ReadHTMLBefehle()

	;****************************
	;* Lese FontColor Codes aus *
	;****************************
	Restore HTML_FontColorCodes
	Read CodeDef$
	
	While Not CodeDef$ = "eof"
		Read Code
		i = i + 1
		HTML_FontColorCodeDef$(i) = CodeDef$
		HTML_FontColorCode(i) = Code
		Read CodeDef$
	Wend : i=0

	;***************************
	;* Lese SonderTags aus     *
	;***************************

	Restore HTML_SonderTags
	Read tag$
	
	While Not tag$ = "eof"
		Read translation$
		i = i + 1
		HTML_SonderTag$(i, 0) = tag$
		HTML_SonderTag$(i, 1) = translation$
		Read tag$
	Wend
	
	HTML_SonderTag$(i+1, 0) = "quot"   ;Diese Zeilen mssen hier stehen, da man das Zeichen " nicht 
	HTML_SonderTag$(i+1, 1) = Chr$(34) ;in Data einflieen lassen kann.

	;***************************
	;* Lese alle Parameter aus *
	;***************************
	
	Restore HTML_Parameter
	Read parameter$
	
	While Not parameter$ = "eof"
		ParPointer = ParPointer + 1
		HTML_ParameterDef$(ParPointer) = parameter$
		
		Read parameter$
	Wend
	;///////////////////////////
	
	;*************************
	;* Lese alle Befehle aus *
	;*************************
	
	Restore HTML_Befehle
	Read befehl$
	
	While Not befehl$ = "eof"
		BefPointer = BefPointer + 1
		HTML_BefehlDef$(BefPointer) = befehl$

				
		Read ParAnz ;Parameteranzahl auslesen

		If ParAnz>0 ;Wenn es mehr als 0 Parameter gibt

			HTML_BefehlDefParameterDef(BefPointer, 0) = ParAnz ;Parameteranzahl abspeichern

			For a=1 To ParAnz ;Alle Parameter einmal durchgehen

				Read Parameter$ ;Parameter auslesen

				; //////////////////////////////////////////////
				; /			Parametercode bestimmen            /
				; //////////////////////////////////////////////

				For ParIndex = 1 To ParPointer ;Parametercode finden

					If HTML_ParameterDef$(ParIndex) = Parameter$ ;Parameter wurde gefunden

						index = index + 1
						HTML_BefehlDefParameter(index) = ParIndex ;Speichere den Parametercode ab
						

						If HTML_BefehlDefParameterDef(BefPointer, 1) = 0 ;1.Position des Parameters
																		 ;bestimmen
																		
							HTML_BefehlDefParameterDef(BefPointer, 1) = index ;Indexnummer abspeichern
							
						End If
						
						Exit
						
					End If
					
				Next
				
			Next
			
		End If
		
		
		Read befehl$
	Wend
	
	HTML_BefehlDefinitionen = BefPointer
	HTML_ParameterDefinitionen = ParPointer
End Function

Function HTML_ReadWert$(st$, find$ = "=")
 For a=1 To Len(st$)
  If Mid$(st$,a,1)=find$ Then st$=HTML_Trim$(Right$(st$,Len(st$)-a)) : Exit
 Next
 z$=Lower$(st$)
 If z$="true" Then st$="1"
 If z$="false" Then st$="0"
 Return st$
End Function

Function HTML_ReadHTMLLine$(file)

	; Liest solange Zeilen aus, wie leere Zeilen gefunden werden
	While Not Eof(file)
		zeile$ = ReadLine$(file)

		; HTML_Trimt die Zeile und ersetzt Tab mit ""
		zeile$ = Replace$(HTML_Trim$(zeile$), Chr$(9), "")

		If zeile$<>""
			For i =  1 To Len(zeile$)
				st$ = Mid$(zeile$, i, 1)

								
				If st$=" " And Mid$(zeile$, i+1, 1)<> " " Or st$<>" " Then newzeile$ = newzeile$ + st$
			Next
			zeile$ = newzeile$
			Exit
		End If
		
		Exit
	Wend
		
	Return zeile$
		
End Function

Function HTML_RenderHTML()
	
	If HTML_HTMLRendered = True Return
	
	HTML_LoadDefaultValues() ;Standardwerte laden
	
	HTML_ClearImage() ;Zeichenflche subern
	
	HTML_ResetPointer()
	
	curbuffer = GraphicsBuffer()
	SetBuffer ImageBuffer(HTML_HTMLImage) ;Auf das HauptImage umschalten
		
	While HTML_NextBefehlExists()

		BefCode    = HTML_NextBefehl()  ;Befehlscode holen			
		BefehlType = HTML_getBefehlType() ; Type holen

		If BefehlType = TYPE_Befehl ;Es handelt sich um einen Befehl
			
			befehl$ = HTML_BefehlDef$(BefCode) ;Hole die Beschreibung zum Code
;			Print
;			Print
;			Print befehl$
;			Delay 500
			
			Select befehl$ ;Finde den Befehl und rendere
				
				Case "br" : HTML_DoZeilenUmbruch()
					
				Case "center" : HTML_DoParameter() : HTML_DoZeilenUmbruch() : HTML_FontCenter = 1

				Case "font" : HTML_DoParameter()
					
				Case "h1" : HTML_DoZeilenUmbruch() : HTML_setFontSize(37, BefCode)
													 HTML_setFontBold(True, BefCode)
				Case "html" ;Bleibt Leer
				
				Case "i" : HTML_setFontItalic(True, BefCode)
				
				Case "img" : HTML_DoParameter()
				
				Case "title"
					
						EndTag = HTML_FindEndTag(HTML_BefehlPointer) ;Finde den EndTag zu title

						If EndTag>0 ;Wenn ein EndTag gefunden wurde

							If HTML_HTMLTitle$=""
							
								HTML_HTMLTitle$ = HTML_getHTMLText$(HTML_BefehlPointer, EndTag) ;Titel setzen
								AppTitle HTML_HTMLTitle$
								
							End If
							
							HTML_BefehlPointer = EndTag

						End If

				Case "u" : HTML_setFontUnderlined(True, BefCode)
				
			End Select				

		Else
		
		If BefehlType = TYPE_EndTag ;Es handelt sich um ein End-Tag

			HTML_EndBefehl()
					
		Else
		
			If BefehlType = TYPE_Text ;Es handelt sich um normaler Text

				HTML_RenderText(HTML_getText$())
				
			End If
	
		End If
		End If
	Wend
	
	SetBuffer curBuffer
	
	HTML_HTMLRendered = True

End Function

Function HTML_RenderObject(obj, objType, word$="")

	sizex = HTML_HTMLSizeX				;HTML-Breite
	sizey = ImageHeight(HTML_HTMLImage) ;HTML-Hhe

	Select objType ;Suche den ObjektType heraus

		Case HTML_ObjectImage ;Wenn es sich um ein Bild handelt

				objWidth 	= ImageWidth(obj)
				objHeight 	= ImageHeight(obj)		

		Case HTML_ObjectText ;Wenn es sich um einen Text handelt
				
				objWidth = StringWidth(word$)
				objHeight = HTML_FontSize * HTML_FontOffset#

				CurOffset = HTML_FontSize - objHeight ;Wenn der TextOffset grer als der
													  ;momentane Offset ist
				
				If CurOffset > HTML_CurOffset HTML_CurOffset = CurOffset ;Setze neuen
																		 ; Offset

	End Select
		
	If HTML_CurX>0 And HTML_CurX + objWidth > SizeX - HTML_CurStart ; Prft ob der Text grer als das Image ist

			HTML_DoZeilenUmbruch() ; Zeilenumbruch durchfhren
			
	End If
	

	If objHeight > HTML_CurMaxHeight ;Prft, ob die Texthhe die momentan Maximale Hhe berschreitet

		x2 = HTML_CurX - HTML_CurStart  ;Falls HTML_CurStart gesetzt ist

		; Zur Erinnerung! HTML_FontOffset deswegen, damit kleine und groe Schrift auf einer
		; Zeile in einer Hhe sind. Bei einem "g" z.B. hngt die Kleine Schrift am Zipfel des
		; g's, wenn kein Offset angewendet wird...

		newY = ObjHeight - HTML_CurMaxHeight ;Legt den neuen Y-Wert fest

		; Schneidet die derzeit gerenderte Zeile aus und versetzt sie auf die neue Hhe
		; HTML_CurMaxHeight
		CopyRect HTML_CurStart, HTML_CurY, x2, HTML_CurMaxHeight + HTML_CurOffset, HTML_CurStart, HTML_CurY + newY

		
		Color 0,0,HTML_BgColor
	
		Rect HTML_CurStart, HTML_CurY, x2, newy ;Der berrest wird bermalt
		
		Color 0,0,HTML_FontColor
			
		HTML_CurMaxHeight = ObjHeight ;MaxHhe der Zeile auf die Hhe des momentanen Objekt setzen
	End If

	
	HTML_LastObject = objType ;Dieses Objekt als letztes Objekt abspeichern

	If objHeight < HTML_CurMaxHeight ZuY = HTML_CurMaxHeight - objHeight
												;Wenn das Bild Kleiner als
												;das die momentane Hhe ist

	Select objType ;Zeichne das Objekt
	
		Case HTML_ObjectImage ; Wenn es sich um ein Bild handelt
																
				DrawBlock obj, HTML_CurX, HTML_CurY + ZuY ;Zeichen das Bild


		Case HTML_ObjectText ;Wenn es sich um ein Text handelt
					
				Text HTML_CurX, HTML_CurY + ZuY, word$ + " "
	End Select	

	HTML_CurX = HTML_CurX + objWidth + StringWidth(" ");Verschiebe den X-Cursor


End Function

Function HTML_RenderText(st$)
	
;	Imgw = HTML_HTMLSizeX		   ;Bildbreite
;	Imgh = ImageHeight(HTML_HTMLImage) ;Bildhhe


;	TextH = HTML_FontSize ;Texthhe ermitteln

	;Print
	;	Print
	;	Print
	;	Print
	;	Print "-----> " + st$
	;	Delay 500
		
	While HTML_NextWordExists(st$) ;Prfung ob noch wrter existieren

		word$ = HTML_NextWord$(st$) ;Holt das Word
		HTML_RenderObject(0, HTML_ObjectText, word$)
;		TextW = StringWidth(word$)  ;Textbreite

;		If HTML_Curx>0 And HTML_CurX + TextW > Imgw - HTML_CurStart ; Prft ob der Text grer als das Image ist

;			HTML_DoZeilenUmbruch() ; Zeilenumbruch durchfhren
;			
;		End If
;		
;		; ///////////////////////////////////////////////////
;		; / Prfung auf Y-bergre der momentanen Y-Hhe   /
;		; ///////////////////////////////////////////////////
;		If TextH > HTML_CurMaxHeight ;Prft, ob die Texthhe die momentan Maximale Hhe berschreitet
;
;			x2 = HTML_CurX - HTML_CurStart  ;Falls HTML_CurStart gesetzt ist
;
;			; Zur Erinnerung! HTML_FontOffset deswegen, damit kleine und groe Schrift auf einer
;			; Zeile in einer Hhe sind. Bei einem "g" z.B. hngt die Kleine Schrift am Zipfel des
;			; g's, wenn kein Offset angewendet wird...
;			
;			newY = ((TextH * HTML_FontOffset#) - (HTML_CurMaxHeight * HTML_FontOffset#)) ;Legt den neuen Y-Wert fest
;
;			; Schneidet die derzeit gerenderte Zeile aus und versetzt sie auf die neue Hhe
;			; HTML_CurMaxHeight
;			CopyRect HTML_CurStart, HTML_CurY, x2, HTML_CurMaxHeight, HTML_CurStart, HTML_CurY + newY
;
;			Color 0,0,HTML_BgColor
;			Rect HTML_CurStart, HTML_CurY, x2, newy ;Der berrest wird bermalt
;			Color 0,0,HTML_FontColor
;			
;			HTML_CurMaxHeight = TextH ;MaxHhe der Zeile auf die Hhe des momentanen Objekt setzen
;
;		End If
;		
;		; /////////////
;		; / Zeichnung /
;		; /////////////
;		If TextH < HTML_CurMaxHeight ZuY = (HTML_CurMaxHeight* HTML_FontOffset#) - (TextH* HTML_FontOffset# ) ;Wenn der Text Kleiner als
;																	 ;der grte Text in der Zeile
;																	 ;ist
;		Text HTML_CurX, HTML_CurY + ZuY, word$ + " " : zuY = 0
;		
;		HTML_CurX = HTML_CurX + TextW + StringWidth(" ") ;Verschiebe den X-Cursor um die Gre des
														 ;Textes
	Wend
	
End Function

Function HTML_ResetPointer()

	HTML_BefehlPointer = 0
	HTML_BufferPointer = 0
	HTML_ParameterPointer = 0
	HTML_TextPointer = 0
	HTML_NextWordPointer = 1

End Function

Function HTML_RepaintDocument()
	HTML_ClearImage()
End Function

Function HTML_SaveBuffer(BefCode, ParCode, wert$)

	HTML_BufferPointer = HTML_BufferPointer + 1 	;Verschiebe den Pointer

	HTML_Buffer(HTML_BufferPointer,0) 	 = BefCode 	  	;Speichere den ParameterCode ab
	HTML_Buffer(HTML_BufferPointer,1)	 = ParCode 		;Speichere den BefehelCode

	HTML_BufferWert$(HTML_BufferPointer) = wert$   		;Speichere den vernderten Wert
	
End Function


Function HTML_setFont()
	
	font = HTML_FindFont()
	
	If font = 0

		;Ld den neuen Font
		HTML_Font = LoadFont(HTML_FontName$, HTML_FontSize, HTML_FontisBold, HTML_FontisItalic, HTML_FontisUnderlined)
		
		HTML_addFont()
		
	Else

		; Setzt einen bereits geladenen Font
		HTML_Font = HTML_FontBuffer(font,0)

	End If
	
	SetFont HTML_Font

End Function

Function HTML_setFontBold(isbold, BefCode = 0)

	If BefCode >0 ;Falls der Flag 'savetobuffer' gegeben wurde, dann abspeichern
		HTML_saveBuffer(BefCode, HTML_FindParameter("bold"), HTML_FontisBold) ;Alte Gre sichern
	End If

	HTML_FontisBold = isbold
	
	HTML_setFont()
	
End Function

Function HTML_setFontItalic(isItalic, BefCode = 0)

	If BefCode >0 ;Falls der Flag 'savetobuffer' gegeben wurde, dann abspeichern
		HTML_saveBuffer(BefCode, HTML_FindParameter("italic"), HTML_FontisItalic) ;Alte Gre sichern
	End If

	HTML_FontisItalic = isItalic
	
	HTML_setFont()
	
End Function

Function HTML_setFontSize(size, BefCode = 0)

	If BefCode >0 ;Falls der Flag 'savetobuffer' gegeben wurde, dann abspeichern
		HTML_saveBuffer(BefCode, HTML_FindParameter("size"), HTML_FontSize) ;Alte Gre sichern
	End If

	HTML_FontSize = size ;Setzt die neue Gre
	
	HTML_setFont()
	
End Function

Function HTML_setFontSizeByString(size$, BefCode = 0)

	If Left$(size$, 1) = "+" Or Left$(size$, 1) = "-"
		fontSize = HTML_FontStandardSize + Int(size$)
	Else
		zu = Int(size$) : If zu>7 Then zu = 7 ;Falls die Gre 7 bersteigt
		fontSize = 5+(zu*8) ;Setze neue Gre
	End If
	
	HTML_setFontSize(fontSize, BefCode)
	
End Function

Function HTML_setFontUnderlined(isUnderlined, BefCode = 0)

	If BefCode >0 ;Falls der Flag 'savetobuffer' gegeben wurde, dann abspeichern
		HTML_saveBuffer(BefCode, HTML_FindParameter("underlined"), HTML_FontisUnderlined) ;Alte Gre sichern
	End If

	HTML_FontisUnderlined = isUnderlined
	
	HTML_setFont()
	
End Function

Function HTML_setOffset(x,y)

	If x<0 Then x=0
	If y<0 Then y=0
	
	HTML_OffsetX = x
	HTML_OffsetY = y
	
End Function


Function HTML_setPos(x, y=0)
	
	HTML_HTMLPosX = x
	HTML_HTMLPosY = y
	
End Function

Function HTML_setSize(x, y)

	ox = HTML_HTMLSizeX
	oy = HTML_HTMLSizeY
	
	If x<1 Then x = 1
	If y<1 Then y = 1
	
	HTML_HTMLSizeX = x ;Neue XGre setzen
	HTML_HTMLSizeY = y ;Neue YGre setzen
	
	If HTML_HTMLImage>0 ;Es darf nur verndert werden, wenn das Image existiert

		If ox <> x HTML_HTMLRendered = False
		
	End If
	
End Function

Function HTML_TranslateCommands$(word$)
	pointer = Instr(word$, "&") ;Suche nach dem ersten "&"
	
	If pointer = 0 Then Return word ;Wenn kein & wurde, dann zurckkehren
	
	If pointer>1 Then newWord$ = Left$(Word$, pointer-1);Hole Wort falls "hallo&nbsp;"
	
	While pointer>0 ;Solange "&" gefunden wird validieren
		pointer = pointer + 1
		
		Repeat ;Fine den EndTag ";"
			endTag = Instr(word$, ";", pointer) ;Finde das Ende des Codes

			nextpointer = Instr(word$, "&", pointer) ;Prfe ob der EndTag nicht in den nchsten Tag
													 ;berlabt. Bsp. &kaputt&nbsp;

			If nextpointer>0 And endtag>nextpointer ;Wenn der Endtag ber das nchste "&" geht
				; Hole den zwischenteil
				; Bsp &123&nsbp;
				newWord$ = newWord$ + Mid$(word$, pointer-1, nextpointer - (pointer-1))

				Exit
			End If
			
			If endTag >0 ;Wenn ";" gefunden wurde
				tag$ = Mid$(word$, pointer, endtag - pointer) ;Hole den Tag
				Exit
			End If
			
			; Wenn kein ";" gefunden wurde und der Pointer am Ende ist, den letzten Rest ausschneiden
			If endTag = 0 Then newWord$ = newWord$ + Right$(word$, Len(word$) - (pointer - 2)) : Exit
		Forever
		
		If Left$(tag$, 1)="#" ;AscII-Zeichen gefunden Bsp. &#31;
			ascii = Right(tag$, Len(tag$) - 1)
			newWord$ = newWord$ + Chr$(ascii)
		Else
		
			For i=1 To 100
				If HTML_SonderTag$(i,0)="" Exit ;Wenn nichts mehr im Array steht
			
				; Der Tag wurde gefunden und wird entsprechend ersetzt
				If tag$ = HTML_SonderTag$(i, 0) Then newWord$ = newWord$ + HTML_SonderTag$(i, 1)
			Next
			
		End If
		
		pointer = Instr(word$, "&", pointer) : tag$ = "" ;Siehe nach nchstem "&"
		
		;Prfen ob zwischen den vorigen & und nchsten & Buchstaben existieren
		If endTag>0 And pointer>0 And endtag+1 < pointer;Es wurde zwischentext gefunden
			newWord$ = newWord$ + Mid$(word$, endtag+1, pointer-(endtag+1))
		End If
		
		;Kein "&" gefunden und es folgt auch keiner mehr. Dennoch existiert Text danach
		If pointer = 0 And nextpointer=0 And endTag>0 And endTag<Len(word$)
			newWord$ = newWord$ + Right$(word$, Len(word$)-endtag)
		End If
	Wend

	Return newWord$
End Function

; berladen der Funktion "HTML_Trim"
Function HTML_Trim$(st$)

	For a=1 To Len(st$)
		If Mid$(st$,a,1)<>" " Then Exit
	Next

	For b=Len(st$) To 1 Step -1
		If Mid$(st$,b,1)<>" " Then b=b+1:Exit
	Next

	Return Mid$(st$, a, b-a)
	
End Function

.HTML_Befehle
Data "b"			, 0

Data "br"			, 0

Data "br /"			, 0

Data "center"		, 0

Data "h1"			, 0

Data "html"			, 0

Data "font"			, 2, "color", "size"

Data "i"			, 0

Data "img"			, 1, "src"

Data "title"		, 0

Data "u"			, 0


Data "eof"

.HTML_Parameter
Data "color", "bold", "italic", "underlined", "size", "src", "Eof"

.HTML_SonderTags
Data "amp", "&"
Data "gt", ">"
Data "lt", "<"
Data "nbsp"," "
Data "eof"

.HTML_FontColorCodes
Data "aliceblue", $F0F8FF
Data "antiquewhite", $FFAEBD7
Data "aquamarine", $7FFFD4
Data "azure", $F0FFFF
Data "beige", $F5F5DC
Data "blue", $0000FF
Data "blueviolet", $8A2BE2
Data "brown", $A52A2A 	
Data "burlywood", $DEB887 	
Data "cadetblue", $5F9EA0 	
Data "chartreuse", $7FFF00 	
Data "chocolate", $D2691E
Data "coral", $FF7F50
Data "cornflowerblue", $6495ED
Data "cornsilk", $FFF8DC
Data "crimson", $DC143C
Data "darkblue", $00008B
Data "darkcyan", $008B8B
Data "darkgoldenrod", $B8860B
Data "darkgray", $A9A9A9
Data "darkgreen", $006400
Data "darkkhaki", $BDB76B
Data "darkmagenta", $8B008B
Data "darkolivegreen", $556B2F
Data "darkorange", $FF8C00
Data "darkorchid", $9932CC
Data "darkred", $8B0000
Data "darksalmon", $E9967A
Data "darkseagreen", $8FBC8F
Data "darkslateblue", $483D8B
Data "darkslategray", $2F4F4F
Data "darkturquoise", $00CED1
Data "darkviolet", $9400D3
Data "deeppink", $FF1493
Data "deepskyblue", $00BFFF
Data "dimgray", $696969
Data "dodgerblue", $1E90FF
Data "firebrick", $B22222
Data "floralwhite", $FFFAF0
Data "forestgreen", $228B22
Data "gainsboro", $DCDCDC
Data "ghostwhite", $F8F8FF
Data "gold", $FFD700
Data "goldenrod", $DAA520
Data "green", $00FF00
Data "greenyellow", $ADFF2F
Data "honeydew", $F0FFF0
Data "hotpink", $FF69B4
Data "indianred", $CD5C5C
Data "indigo", $4B0082
Data "ivory", $FFFFF0
Data "khaki", $F0E68C
Data "lavender", $E6E6FA
Data "lavenderblush", $FFF0F5
Data "lawngreen", $7CFC00
Data "lemonchiffon", $FFFACD
Data "lightblue", $ADD8E6
Data "lightcoral", $F08080
Data "lightcyan", $E0FFFF
Data "lightgoldenrodyellow", $FAFAD2
Data "lightgreen", $90EE90
Data "lightgrey", $D3D3D3
Data "lightpink", $FFB6C1
Data "lightsalmon", $FFA07A
Data "lightseagreen", $20B2AA
Data "lightskyblue", $87CEFA
Data "lightslategray", $778899
Data "lightsteelblue", $B0C4DE
Data "lightyellow", $FFFFE0
Data "limegreen", $32CD32
Data "linen", $FAF0E6
Data "mediumaquamarine", $66CDAA
Data "mediumblue", $0000CD
Data "mediumorchid", $BA55D3
Data "mediumpurple", $9370D
Data "mediumseagreen", $3CB371
Data "mediumslateblue", $7B68EE
Data "mediumspringgreen", $00FA9A
Data "mediumturquoise", $48D1CC
Data "mediumvioletred", $C71585
Data "midnightblue", $191970
Data "mintcream", $F5FFFA
Data "mistyrose", $FFE4E1
Data "moccasin", $FFE4B5
Data "navajowhite", $FFDEAD
Data "oldlace", $FDF5E6
Data "olivedrab", $6B8E23
Data "orange", $FFA500
Data "orangered", $FF4500
Data "orchid", $DA70D6
Data "palegoldenrod", $EEE8AA
Data "palegreen", $98FB98
Data "paleturquoise", $AFEEEE
Data "palevioletred", $DB7093
Data "papayawhip", $FFEFD5
Data "peachpuff", $FFDAB9
Data "peru", $CD853F
Data "pink", $FFC0CB
Data "plum", $DDA0DD
Data "powderblue", $B0E0E6
Data "red", $FF0000
Data "rosybrown", $BC8F8F
Data "royalblue", $4169E1
Data "saddlebrown", $8B4513
Data "salmon", $FA8072
Data "sandybrown", $F4A460
Data "seagreen", $2E8B57
Data "seashell", $FFF5EE
Data "sienna", $A0522D
Data "skyblue", $87CEEB
Data "slateblue", $6A5ACD
Data "slategray", $708090
Data "snow", $FFFAFA
Data "springgreen", $00FF7F
Data "steelblue", $4682B4
Data "Tan", $D2B48C
Data "thistle", $D8BFD8
Data "tomato", $FF6347
Data "turquoise", $40E0D0
Data "violet", $EE82EE
Data "wheat", $F5DEB3
Data "whitesmoke", $F5F5F
Data "yellowgreen", $9ACD32
Data "yellow", $FFFF00
Data "eof"
;~IDEal Editor Parameters:
;~C#Blitz3D